#include <stdio.h>
#include <string.h>
#include "wmsdk_config.h"
#include "wm_event.h"
#include "wm_wifi.h"
#include "lwipopts.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "lwip/sockets.h"
#include "lwip/netdb.h"
#include "wm_http_client.h"
#include "wm_nm_api.h"
#include "cJSON/cJSON.h"
#include "ui/ui.h"

#define LOG_TAG "example"
#include "wm_log.h"

/* The examples use WiFi configuration that you can set via project configuration menu

   If you'd rather not, just change the below entries to strings with
   the config you want - ie #define CONFIG_EXAMPLE_WIFI_SSID "mywifissid"
*/

#define HTTPC_CLIENT_BUFFER_SIZE     4096
#define HTTPC_CLIENT_DEFAULT_TIMEOUT 30000

static void wm_httpc_event_handle(wm_http_client_t session, wm_http_client_event_t event, wm_http_client_event_param_t *param,
                                  void *priv)
{
    switch (event) {
        case WM_HTTP_CLIENT_EVENT_CONNECTED:
            wm_log_info("WM_HTTP_CLIENT_EVENT_CONNECTED");
            break;
        case WM_HTTP_CLIENT_EVENT_DISCONNECTED:
            wm_log_info("WM_HTTP_CLIENT_EVENT_DISCONNECTED");
            break;
        case WM_HTTP_CLIENT_EVENT_HEADER_SENTED:
            wm_log_info("WM_HTTP_CLIENT_EVENT_HEADER_SENTED");
            wm_log_info("%s", (char *)(param->data));
            break;
        case WM_HTTP_CLIENT_EVENT_RECV_HEADER:
            wm_log_info("WM_HTTP_CLIENT_EVENT_RECV_HEADER");
            wm_log_info("%s", (char *)(param->data));
            break;
        case WM_HTTP_CLIENT_EVENT_RECV_DATA:
            wm_log_info("WM_HTTP_CLIENT_EVENT_RECV_DATA");
            wm_log_info("%s", (char *)(param->data));
            {
                wm_log_info("WM_HTTP_CLIENT_EVENT_RECV_DATA");
                // wm_log_info("%s", (char *)(param->data));
                cJSON *root = cJSON_Parse((char *)(param->data));
                if(root == NULL)
                {
                    break;
                }

                cJSON *results = NULL;
                cJSON *location = NULL;
                cJSON *daily = NULL;
                cJSON *item = NULL;
                cJSON *item1 = NULL;
                cJSON *day = NULL;

                if((root = cJSON_GetObjectItem(root,"results")) != NULL)
                {
                    if((results = cJSON_GetArrayItem(root, 0)) !=  NULL) {
                        if((location = cJSON_GetObjectItem(results,"location")) != NULL) {
                            if((item = cJSON_GetObjectItem(location,"name")) != NULL) {
                                printf("---> name:%s\r\n", item->valuestring);
                                lv_label_set_text(ui_LabelAddr, item->valuestring);
                            }
                        }
                        if((daily = cJSON_GetObjectItem(results,"daily")) != NULL) {
                            // printf("cJSON_GetArraySize: %d\r\n",  cJSON_GetArraySize(daily));
                            if((day = cJSON_GetArrayItem(daily, 0)) !=  NULL) {
                                if((item = cJSON_GetObjectItem(day,"date")) != NULL) {
                                    printf("---> date:%s\r\n", item->valuestring+5);
                                    lv_label_set_text(ui_LabelDate1, item->valuestring+5);
                                }
                                if((item = cJSON_GetObjectItem(day,"text_day")) != NULL) {
                                    printf("---> text_day:%s\r\n", item->valuestring);
                                    lv_label_set_text(ui_LabelWeather1, item->valuestring);

                                    char *result = NULL;
                                    result = strstr(item->valuestring, "云");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco1, &ui_img_cloud_png);
                                    }
                                    result = strstr(item->valuestring, "晴");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco1, &ui_img_sun_png);
                                    }
                                    result = strstr(item->valuestring, "雨");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco1, &ui_img_rain_png);
                                    }
                                    // if (strcmp(item->valuestring, "多云") == 0) {
                                    //     lv_img_set_src(ui_ImageIco1, &ui_img_cloud_png);
                                    // } else if (strcmp(item->valuestring, "晴") == 0) {
                                    //     lv_img_set_src(ui_ImageIco1, &ui_img_sun_png);
                                    // } else if (strcmp(item->valuestring, "小雨") == 0) {
                                    //     lv_img_set_src(ui_ImageIco1, &ui_img_rain_png);
                                    // } 
                                }
                                if((item = cJSON_GetObjectItem(day,"high")) != NULL) {
                                    printf("---> high:%s\r\n", item->valuestring);
                                }
                                if((item1 = cJSON_GetObjectItem(day,"low")) != NULL) {
                                    printf("---> low:%s\r\n", item1->valuestring);
                                }
                                char temperature[10] = {0};
                                sprintf(temperature, "%s/%s°C", item->valuestring, item1->valuestring);
                                lv_label_set_text(ui_LabelTemperature1, temperature);
                            }
                            if((day = cJSON_GetArrayItem(daily, 1)) !=  NULL) {
                                if((item = cJSON_GetObjectItem(day,"date")) != NULL) {
                                    printf("---> date:%s\r\n", item->valuestring+5);
                                    lv_label_set_text(ui_LabelDate2, item->valuestring+5);
                                }
                                if((item = cJSON_GetObjectItem(day,"text_day")) != NULL) {
                                    printf("---> text_day:%s\r\n", item->valuestring);
                                    lv_label_set_text(ui_LabelWeather2, item->valuestring);
                                    char *result = NULL;
                                    result = strstr(item->valuestring, "云");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco2, &ui_img_cloud_png);
                                    }
                                    result = strstr(item->valuestring, "晴");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco2, &ui_img_sun_png);
                                    }
                                    result = strstr(item->valuestring, "雨");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco2, &ui_img_rain_png);
                                    }
                                    // if (strcmp(item->valuestring, "多云") == 0) {
                                    //     lv_img_set_src(ui_ImageIco2, &ui_img_cloud_png);
                                    // } else if (strcmp(item->valuestring, "晴") == 0) {
                                    //     lv_img_set_src(ui_ImageIco2, &ui_img_sun_png);
                                    // } else if (strcmp(item->valuestring, "小雨") == 0) {
                                    //     lv_img_set_src(ui_ImageIco2, &ui_img_rain_png);
                                    // } 
                                }
                                if((item = cJSON_GetObjectItem(day,"high")) != NULL) {
                                    printf("---> high:%s\r\n", item->valuestring);
                                }
                                if((item1 = cJSON_GetObjectItem(day,"low")) != NULL) {
                                    printf("---> low:%s\r\n", item1->valuestring);
                                }
                                char temperature[10] = {0};
                                sprintf(temperature, "%s/%s°C", item->valuestring, item1->valuestring);
                                lv_label_set_text(ui_LabelTemperature2, temperature);
                            }
                            if((day = cJSON_GetArrayItem(daily, 2)) !=  NULL) {
                                if((item = cJSON_GetObjectItem(day,"date")) != NULL) {
                                    printf("---> date:%s\r\n", item->valuestring+5);
                                    lv_label_set_text(ui_LabelDate3, item->valuestring+5);
                                }
                                if((item = cJSON_GetObjectItem(day,"text_day")) != NULL) {
                                    printf("---> text_day:%s\r\n", item->valuestring);
                                    lv_label_set_text(ui_LabelWeather3, item->valuestring);
                                    char *result = NULL;
                                    result = strstr(item->valuestring, "云");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco3, &ui_img_cloud_png);
                                    }
                                    result = strstr(item->valuestring, "晴");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco3, &ui_img_sun_png);
                                    }
                                    result = strstr(item->valuestring, "雨");
                                    if(result){
                                        lv_img_set_src(ui_ImageIco3, &ui_img_rain_png);
                                    }
                                    // if (strcmp(item->valuestring, "多云") == 0) {
                                    //     lv_img_set_src(ui_ImageIco3, &ui_img_cloud_png);
                                    // } else if (strcmp(item->valuestring, "晴") == 0) {
                                    //     lv_img_set_src(ui_ImageIco3, &ui_img_sun_png);
                                    // } else if (strcmp(item->valuestring, "小雨") == 0) {
                                    //     lv_img_set_src(ui_ImageIco3, &ui_img_rain_png);
                                    // } 
                                }
                                if((item = cJSON_GetObjectItem(day,"high")) != NULL) {
                                    printf("---> high:%s\r\n", item->valuestring);
                                }
                                if((item1 = cJSON_GetObjectItem(day,"low")) != NULL) {
                                    printf("---> low:%s\r\n", item1->valuestring);
                                }
                                char temperature[10] = {0};
                                sprintf(temperature, "%s/%s°C", item->valuestring, item1->valuestring);
                                lv_label_set_text(ui_LabelTemperature3, temperature);
                            }
                        }
                    }
                }
                cJSON_Delete(root);
                break;
            }
        case WM_HTTP_CLIENT_EVENT_FINISH:
            wm_log_info("WM_HTTP_CLIENT_EVENT_FINISH");
            break;
    }
    return;
}

static int wm_httpc_example_send_req(wm_http_client_config_t *cfg, char *url, char *data /*post data*/, uint32_t len)
{
    int ret;
    size_t size, total = 0;
    char *buffer = NULL;
    wm_http_client_t session;

    do {
        buffer = (char *)malloc(HTTPC_CLIENT_BUFFER_SIZE);
        if (buffer == NULL) {
            return WM_ERR_NO_MEM;
        }
        memset(buffer, 0, HTTPC_CLIENT_BUFFER_SIZE);

        // Open the HTTP request handle
        session = wm_http_client_open_request(cfg);
        if (!session) {
            ret = WM_ERR_FAILED;
            break;
        }

        if ((ret = wm_http_client_send_request(session, url, data, len, true, 0, 0)) != WM_ERR_SUCCESS) {
            break;
        }

        // Retrieve the the headers and analyze them
        if ((ret = wm_http_client_recv_response(session, HTTPC_CLIENT_DEFAULT_TIMEOUT)) != WM_ERR_SUCCESS) {
            break;
        }
        wm_log_info("Start to receive data from remote server...");

        // Get the data until we get an error or end of stream code
        while (ret == WM_ERR_SUCCESS || ret != WM_ERR_EOS) {
            // Set the size of our buffer
            size = HTTPC_CLIENT_BUFFER_SIZE;
            // Get the data
            ret = wm_http_client_read_data(session, buffer, size, HTTPC_CLIENT_DEFAULT_TIMEOUT, &size);
            if (ret != WM_ERR_SUCCESS && ret != WM_ERR_EOS)
                break;
            total += size;
        }
    } while (0);

    free(buffer);

    if (session)
        ret = wm_http_client_close_request(&session);

    return ret;
}

int wm_example_httpc_set_content_type(void)
{
    wm_http_client_config_t cfg = { 0 };

    cfg.method        = WM_HTTP_CLIENT_REQUEST_TYPE_GET;
    cfg.keep_alive    = 1;
    cfg.content_type  = WM_HTTP_CLIENT_CONTENT_APPLICATION_JSON;
    cfg.event_handler = wm_httpc_event_handle;

    return wm_httpc_example_send_req(&cfg, "https://api.seniverse.com/v3/weather/daily.json?key=SoN6W4qEok02ndiXO&location=ip&language=zh-Hans&unit=c&start=0&days=3", NULL, 0);
}

static void httpc_request_task(void *pvParameters)
{
    wm_example_httpc_set_content_type();
    vTaskDelete(NULL);
}


int user_weather(void)
{
    xTaskCreate(httpc_request_task, "http_client_task", 1024, NULL, 8, NULL);
    return 0;
}
